﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace example
{
    public partial class Form1 : Form
    {
        /////////////////////////////////////////////////////////////////////////////
        [DllImport("pdftotiff.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MLoad(string filename,string password);

        [DllImport("pdftotiff.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncode(int id,int pageno);

        [DllImport("pdftotiff.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MFree(int id);

        [DllImport("pdftotiff.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MGetCount(int id);

        [DllImport("pdftotiff.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam( int id,string outpath,int imagetype,int bitcount,
								          int compression,int quality,int grayscale,int multipage,
								          int rotate,int width,int height,int xdpi,int ydpi);

        /////////////////////////////////////////////////////////////////////////////
        const int IMAGE_FORMAT_TIF = 1;
        const int IMAGE_FORMAT_TGA = 2;
        const int IMAGE_FORMAT_PNG = 3;

        /////////////////////////////////////////////////////////////////////////////
        //The compression method in the generated TIFF file.
        const int COMPRESSION_NONE		= 1;		/* dump mode */
        const int COMPRESSION_CCITTRLE	= 2;		/* CCITT modified Huffman RLE */
        const int COMPRESSION_CCITTFAX3	= 3;		/* CCITT Group 3 fax encoding */
        const int COMPRESSION_CCITTFAX4	= 4;		/* CCITT Group 4 fax encoding */
        const int COMPRESSION_LZW		= 5;		/* Lempel-Ziv  & Welch */
        const int COMPRESSION_JPEG		= 7;		/* %JPEG DCT compression */
        const int COMPRESSION_PACKBITS	= 32773;	/* Macintosh RLE */       
        
        
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int id = MLoad("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            //The 1 is generate a multi-page TIFF file, the 0 is generate a TIFF file for each page
            int multipages = 1;
            MSetParam(id, "", IMAGE_FORMAT_TIF, 24, COMPRESSION_LZW, 0, 0, multipages, 0, 0, 0, 96, 96);

            int pageCount = MGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                MEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int id = MLoad("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            //The 1 is generate a multi-page TIFF file, the 0 is generate a TIFF file for each page
            int multipages = 0;
            MSetParam(id, "", IMAGE_FORMAT_TIF, 8, COMPRESSION_JPEG, 75, 0, multipages, 90, 800, 600, 120, 120);

            int pageCount = MGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                MEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }
    }
}
